#line 1 "C:/Users/LF/Desktop/1kohm/Ventola con LCD/Code/Ventola_LCD.c"
sbit LCD_RS at RB5_bit;
sbit LCD_EN at RB4_bit;
sbit LCD_D4 at RB3_bit;
sbit LCD_D5 at RB2_bit;
sbit LCD_D6 at RB1_bit;
sbit LCD_D7 at RB0_bit;

sbit LCD_RS_Direction at TRISB5_bit;
sbit LCD_EN_Direction at TRISB4_bit;
sbit LCD_D4_Direction at TRISB3_bit;
sbit LCD_D5_Direction at TRISB2_bit;
sbit LCD_D6_Direction at TRISB1_bit;
sbit LCD_D7_Direction at TRISB0_bit;


unsigned int Temp;
unsigned short DuCy, Vel;
char txt0[7];
char txt1[7];

void main() {

 TRISC = 0;
 PWM1_Init(6250);
 PWM1_Set_Duty(0);
 PWM1_Start();

 ADC_Init();
 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);

 while(1){
 Temp = ADC_Read(1);
 Temp = Temp * 0.48828;

 if(Temp < 30){
 DuCy = 0;
 PWM1_Set_Duty(DuCy);
 }

 else if(Temp > 80){
 DuCy = 255;
 PWM1_Set_Duty(DuCy);
 }

 else{
 DuCy = Temp * 3.18;
 PWM1_Set_Duty(DuCy);
 }

 Delay_ms(500);

 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_FIRST_ROW);
 Lcd_Out_Cp(" Temp  ");
 IntToStrWithZeros(Temp, txt0);
 Lcd_Out_Cp(txt0);
 Lcd_Out_Cp("^C   ");

 Lcd_Cmd(_LCD_SECOND_ROW);
 Lcd_Out_Cp(" Vel   ");
 DuCy = DuCy/2.55;
 IntToStrWithZeros(DuCy, txt1);
 Lcd_Out_Cp(txt1);
 Lcd_Out_Cp("%");
 }
}
