
_main:

;Ventola_LCD.c,21 :: 		void main() {                        //Programma principale
;Ventola_LCD.c,23 :: 		TRISC = 0;                         //PORTC uscite
	CLRF        TRISC+0 
;Ventola_LCD.c,24 :: 		PWM1_Init(6250);                   //Frequenza PWM 6.25KHz
	BSF         T2CON+0, 0, 0
	BCF         T2CON+0, 1, 0
	MOVLW       79
	MOVWF       PR2+0, 0
	CALL        _PWM1_Init+0, 0
;Ventola_LCD.c,25 :: 		PWM1_Set_Duty(0);                  //PWM spento
	CLRF        FARG_PWM1_Set_Duty_new_duty+0 
	CALL        _PWM1_Set_Duty+0, 0
;Ventola_LCD.c,26 :: 		PWM1_Start();                      //PWM start
	CALL        _PWM1_Start+0, 0
;Ventola_LCD.c,28 :: 		ADC_Init();                        //ADC inizializzato
	CALL        _ADC_Init+0, 0
;Ventola_LCD.c,29 :: 		Lcd_Init();                        //Initializza LCD
	CALL        _Lcd_Init+0, 0
;Ventola_LCD.c,30 :: 		Lcd_Cmd(_LCD_CLEAR);               //Pulisci display
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;Ventola_LCD.c,31 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);          //Disattiva cursore
	MOVLW       12
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;Ventola_LCD.c,33 :: 		while(1){                          //Ciclo infinito
L_main0:
;Ventola_LCD.c,34 :: 		Temp = ADC_Read(1);              //Leggi valore ADC
	MOVLW       1
	MOVWF       FARG_ADC_Read_channel+0 
	CALL        _ADC_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _Temp+0 
	MOVF        R1, 0 
	MOVWF       _Temp+1 
;Ventola_LCD.c,35 :: 		Temp = Temp * 0.48828;           //Converti in gradi centigradi
	CALL        _word2double+0, 0
	MOVLW       214
	MOVWF       R4 
	MOVLW       255
	MOVWF       R5 
	MOVLW       121
	MOVWF       R6 
	MOVLW       125
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	CALL        _double2word+0, 0
	MOVF        R0, 0 
	MOVWF       _Temp+0 
	MOVF        R1, 0 
	MOVWF       _Temp+1 
;Ventola_LCD.c,37 :: 		if(Temp < 30){                   //Se la Temp  minore di trenta...
	MOVLW       0
	SUBWF       R1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main8
	MOVLW       30
	SUBWF       R0, 0 
L__main8:
	BTFSC       STATUS+0, 0 
	GOTO        L_main2
;Ventola_LCD.c,38 :: 		DuCy = 0;                      //Duty Cycle
	CLRF        _DuCy+0 
;Ventola_LCD.c,39 :: 		PWM1_Set_Duty(DuCy);           //Ventola spenta
	CLRF        FARG_PWM1_Set_Duty_new_duty+0 
	CALL        _PWM1_Set_Duty+0, 0
;Ventola_LCD.c,40 :: 		}
	GOTO        L_main3
L_main2:
;Ventola_LCD.c,42 :: 		else if(Temp > 80){              //Se la Temp  maggiore di ottanta...
	MOVLW       0
	MOVWF       R0 
	MOVF        _Temp+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main9
	MOVF        _Temp+0, 0 
	SUBLW       80
L__main9:
	BTFSC       STATUS+0, 0 
	GOTO        L_main4
;Ventola_LCD.c,43 :: 		DuCy = 255;                    //Duty cycle 100%
	MOVLW       255
	MOVWF       _DuCy+0 
;Ventola_LCD.c,44 :: 		PWM1_Set_Duty(DuCy);           //Ventola accesa al massimo
	MOVLW       255
	MOVWF       FARG_PWM1_Set_Duty_new_duty+0 
	CALL        _PWM1_Set_Duty+0, 0
;Ventola_LCD.c,45 :: 		}
	GOTO        L_main5
L_main4:
;Ventola_LCD.c,48 :: 		DuCy = Temp * 3.18;            //Moltiplica Temp per 255/TempMax (255/80=3.18)
	MOVF        _Temp+0, 0 
	MOVWF       R0 
	MOVF        _Temp+1, 0 
	MOVWF       R1 
	CALL        _word2double+0, 0
	MOVLW       31
	MOVWF       R4 
	MOVLW       133
	MOVWF       R5 
	MOVLW       75
	MOVWF       R6 
	MOVLW       128
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	CALL        _double2byte+0, 0
	MOVF        R0, 0 
	MOVWF       _DuCy+0 
;Ventola_LCD.c,49 :: 		PWM1_Set_Duty(DuCy);           //Imposta il duty cycle calcolato
	MOVF        R0, 0 
	MOVWF       FARG_PWM1_Set_Duty_new_duty+0 
	CALL        _PWM1_Set_Duty+0, 0
;Ventola_LCD.c,50 :: 		}
L_main5:
L_main3:
;Ventola_LCD.c,52 :: 		Delay_ms(500);                   //0.5S prima di ricontrollare la Temp
	MOVLW       6
	MOVWF       R11, 0
	MOVLW       19
	MOVWF       R12, 0
	MOVLW       173
	MOVWF       R13, 0
L_main6:
	DECFSZ      R13, 1, 1
	BRA         L_main6
	DECFSZ      R12, 1, 1
	BRA         L_main6
	DECFSZ      R11, 1, 1
	BRA         L_main6
	NOP
	NOP
;Ventola_LCD.c,54 :: 		Lcd_Cmd(_LCD_CLEAR);             //Pulisci LCD
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;Ventola_LCD.c,55 :: 		Lcd_Cmd(_LCD_FIRST_ROW);         //Vai alla prima riga
	MOVLW       128
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;Ventola_LCD.c,56 :: 		Lcd_Out_Cp(" Temp  ");           //Scrivi temperatura
	MOVLW       ?lstr1_Ventola_LCD+0
	MOVWF       FARG_Lcd_Out_CP_text+0 
	MOVLW       hi_addr(?lstr1_Ventola_LCD+0)
	MOVWF       FARG_Lcd_Out_CP_text+1 
	CALL        _Lcd_Out_CP+0, 0
;Ventola_LCD.c,57 :: 		IntToStrWithZeros(Temp, txt0);   //Converti in stringa
	MOVF        _Temp+0, 0 
	MOVWF       FARG_IntToStrWithZeros_input+0 
	MOVF        _Temp+1, 0 
	MOVWF       FARG_IntToStrWithZeros_input+1 
	MOVLW       _txt0+0
	MOVWF       FARG_IntToStrWithZeros_output+0 
	MOVLW       hi_addr(_txt0+0)
	MOVWF       FARG_IntToStrWithZeros_output+1 
	CALL        _IntToStrWithZeros+0, 0
;Ventola_LCD.c,58 :: 		Lcd_Out_Cp(txt0);                //Scrivi la temperatura
	MOVLW       _txt0+0
	MOVWF       FARG_Lcd_Out_CP_text+0 
	MOVLW       hi_addr(_txt0+0)
	MOVWF       FARG_Lcd_Out_CP_text+1 
	CALL        _Lcd_Out_CP+0, 0
;Ventola_LCD.c,59 :: 		Lcd_Out_Cp("^C   ");             //Scrivi gradi centigradi
	MOVLW       ?lstr2_Ventola_LCD+0
	MOVWF       FARG_Lcd_Out_CP_text+0 
	MOVLW       hi_addr(?lstr2_Ventola_LCD+0)
	MOVWF       FARG_Lcd_Out_CP_text+1 
	CALL        _Lcd_Out_CP+0, 0
;Ventola_LCD.c,61 :: 		Lcd_Cmd(_LCD_SECOND_ROW);        //Vai alla seconda riga
	MOVLW       192
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;Ventola_LCD.c,62 :: 		Lcd_Out_Cp(" Vel   ");           //Scrivi Vel
	MOVLW       ?lstr3_Ventola_LCD+0
	MOVWF       FARG_Lcd_Out_CP_text+0 
	MOVLW       hi_addr(?lstr3_Ventola_LCD+0)
	MOVWF       FARG_Lcd_Out_CP_text+1 
	CALL        _Lcd_Out_CP+0, 0
;Ventola_LCD.c,63 :: 		DuCy = DuCy/2.55;                //Calcola percentuale
	MOVF        _DuCy+0, 0 
	MOVWF       R0 
	CALL        _byte2double+0, 0
	MOVLW       51
	MOVWF       R4 
	MOVLW       51
	MOVWF       R5 
	MOVLW       35
	MOVWF       R6 
	MOVLW       128
	MOVWF       R7 
	CALL        _Div_32x32_FP+0, 0
	CALL        _double2byte+0, 0
	MOVF        R0, 0 
	MOVWF       _DuCy+0 
;Ventola_LCD.c,64 :: 		IntToStrWithZeros(DuCy, txt1);   //Converti in stringa
	MOVF        R0, 0 
	MOVWF       FARG_IntToStrWithZeros_input+0 
	MOVLW       0
	MOVWF       FARG_IntToStrWithZeros_input+1 
	MOVLW       _txt1+0
	MOVWF       FARG_IntToStrWithZeros_output+0 
	MOVLW       hi_addr(_txt1+0)
	MOVWF       FARG_IntToStrWithZeros_output+1 
	CALL        _IntToStrWithZeros+0, 0
;Ventola_LCD.c,65 :: 		Lcd_Out_Cp(txt1);                //Scrivi la velocit
	MOVLW       _txt1+0
	MOVWF       FARG_Lcd_Out_CP_text+0 
	MOVLW       hi_addr(_txt1+0)
	MOVWF       FARG_Lcd_Out_CP_text+1 
	CALL        _Lcd_Out_CP+0, 0
;Ventola_LCD.c,66 :: 		Lcd_Out_Cp("%");                 //Scrivi %
	MOVLW       ?lstr4_Ventola_LCD+0
	MOVWF       FARG_Lcd_Out_CP_text+0 
	MOVLW       hi_addr(?lstr4_Ventola_LCD+0)
	MOVWF       FARG_Lcd_Out_CP_text+1 
	CALL        _Lcd_Out_CP+0, 0
;Ventola_LCD.c,67 :: 		}//fine ciclo infinito
	GOTO        L_main0
;Ventola_LCD.c,68 :: 		}//fine programma
L_end_main:
	GOTO        $+0
; end of _main
